Index: palm/trunk/SOURCE/microphysics.f90
===================================================================
--- palm/trunk/SOURCE/microphysics.f90	(revision 1821)
+++ palm/trunk/SOURCE/microphysics.f90	(revision 1822)
@@ -19,5 +19,7 @@
 ! Current revisions:
 ! ------------------
-! 
+! Unused variables removed. 
+!
+! Kessler scheme integrated.
 ! 
 ! Former revisions:
@@ -109,4 +111,9 @@
     END INTERFACE autoconversion
 
+    INTERFACE autoconversion_kessler
+       MODULE PROCEDURE autoconversion_kessler
+       MODULE PROCEDURE autoconversion_kessler_ij
+    END INTERFACE autoconversion_kessler
+
     INTERFACE accretion
        MODULE PROCEDURE accretion
@@ -151,14 +158,14 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  hyp, nr, pt, pt_init, q, qc, qr, zu
+           ONLY:  hyp, pt_init, zu
 
        USE cloud_parameters,                                                   &
-           ONLY:  cp, hyrho, nc_const, pt_d_t, r_d, t_d_pt
+           ONLY:  cp, hyrho, prr, pt_d_t, r_d, t_d_pt
 
        USE control_parameters,                                                 &
            ONLY:  call_microphysics_at_all_substeps, drizzle, dt_3d, dt_micro, &
-                  g, intermediate_timestep_count,                              &
-                  large_scale_forcing, lsf_surf, precipitation, pt_surface,    &
-                  rho_surface,surface_pressure
+                  g, intermediate_timestep_count, large_scale_forcing,         &
+                  lsf_surf, microphysics_kessler, microphysics_seifert,        &
+                  pt_surface, rho_surface,surface_pressure
 
        USE indices,                                                            &
@@ -172,6 +179,4 @@
        IMPLICIT NONE
 
-       INTEGER(iwp) ::  i                 !<
-       INTEGER(iwp) ::  j                 !<
        INTEGER(iwp) ::  k                 !<
 
@@ -193,4 +198,5 @@
              hyrho(k)  = hyp(k) / ( r_d * t_d_pt(k) * pt_init(k) )       
           ENDDO
+
 !
 !--       Compute reference density
@@ -207,6 +213,15 @@
 
 !
+!--    Reset precipitation rate
+       IF ( intermediate_timestep_count == 1 )  prr = 0.0_wp
+
+!
 !--    Compute cloud physics
-       IF ( precipitation )  THEN
+       IF ( microphysics_kessler )  THEN
+
+          CALL autoconversion_kessler
+
+       ELSEIF ( microphysics_seifert )  THEN
+
           CALL adjust_cloud
           CALL autoconversion
@@ -215,11 +230,10 @@
           CALL evaporation_rain
           CALL sedimentation_rain
+
+          IF ( drizzle )  CALL sedimentation_cloud
+
        ENDIF
 
-       IF ( drizzle )  CALL sedimentation_cloud
-
-       IF ( precipitation )  THEN
-          CALL calc_precipitation_amount
-       ENDIF
+       CALL calc_precipitation_amount
 
     END SUBROUTINE microphysics_control
@@ -238,5 +252,5 @@
 
        USE cloud_parameters,                                                   &
-           ONLY:  eps_sb, xrmin, xrmax, hyrho, k_cc, x0
+           ONLY:  eps_sb, xrmin, xrmax, hyrho
 
        USE cpulog,                                                             &
@@ -244,5 +258,5 @@
 
        USE indices,                                                            &
-           ONLY:  nxl, nxr, nys, nyn, nzb, nzb_s_inner, nzt
+           ONLY:  nxl, nxr, nys, nyn, nzb_s_inner, nzt
 
        USE kinds
@@ -303,5 +317,5 @@
 
        USE indices,                                                            &
-           ONLY:  nxl, nxr, nys, nyn, nzb, nzb_s_inner, nzt
+           ONLY:  nxl, nxr, nys, nyn, nzb_s_inner, nzt
 
        USE kinds
@@ -323,5 +337,4 @@
        REAL(wp)     ::  rc                !<
        REAL(wp)     ::  re_lambda         !<
-       REAL(wp)     ::  selfcoll          !<
        REAL(wp)     ::  sigma_cc          !<
        REAL(wp)     ::  tau_cloud         !<
@@ -417,4 +430,59 @@
 ! Description:
 ! ------------
+!> Autoconversion process (Kessler, 1969).
+!------------------------------------------------------------------------------!
+    SUBROUTINE autoconversion_kessler
+
+       USE arrays_3d,                                                          &
+           ONLY:  dzw, pt, q, qc
+
+       USE cloud_parameters,                                                   &
+           ONLY:  l_d_cp, pt_d_t, prec_time_const, prr, ql_crit
+
+       USE control_parameters,                                                 &
+           ONLY:  dt_micro
+
+       USE indices,                                                            &
+           ONLY:  nxl, nxr, nyn, nys, nzb_2d, nzt
+
+       USE kinds
+
+
+       IMPLICIT NONE
+
+       INTEGER(iwp) ::  i !<
+       INTEGER(iwp) ::  j !<
+       INTEGER(iwp) ::  k !<
+
+       REAL(wp)    ::  dqdt_precip !<
+
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             DO  k = nzb_2d(j,i)+1, nzt
+
+                IF ( qc(k,j,i) > ql_crit )  THEN
+                   dqdt_precip = prec_time_const * ( qc(k,j,i) - ql_crit )
+                ELSE
+                   dqdt_precip = 0.0_wp
+                ENDIF
+
+                qc(k,j,i) = qc(k,j,i) - dqdt_precip * dt_micro
+                q(k,j,i)  = q(k,j,i)  - dqdt_precip * dt_micro
+                pt(k,j,i) = pt(k,j,i) + dqdt_precip * dt_micro * l_d_cp * pt_d_t(k)
+
+!
+!--             Compute the rain rate
+                prr(nzb_2d(j,i)+1,j,i) = prr(nzb_2d(j,i)+1,j,i) + dqdt_precip * dzw(k)
+
+             ENDDO
+          ENDDO
+       ENDDO
+
+   END SUBROUTINE autoconversion_kessler
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
 !> Accretion rate (Seifert and Beheng, 2006).
 !------------------------------------------------------------------------------!
@@ -434,5 +502,5 @@
 
        USE indices,                                                            &
-           ONLY:  nxl, nxr, nys, nyn, nzb, nzb_s_inner, nzt
+           ONLY:  nxl, nxr, nys, nyn, nzb_s_inner, nzt
 
        USE kinds
@@ -448,5 +516,4 @@
        REAL(wp)     ::  phi_ac            !<
        REAL(wp)     ::  tau_cloud         !<
-       REAL(wp)     ::  xc                !<
 
        CALL cpu_log( log_point_s(56), 'accretion', 'start' )
@@ -516,5 +583,5 @@
 
        USE indices,                                                            &
-           ONLY:  nxl, nxr, nys, nyn, nzb, nzb_s_inner, nzt
+           ONLY:  nxl, nxr, nys, nyn, nzb_s_inner, nzt
 
        USE kinds
@@ -579,8 +646,8 @@
 
        USE cloud_parameters,                                                   &
-           ONLY:  a_term, a_vent, b_term, b_vent, c_evap, c_term, diff_coeff_l,&
-                  dpirho_l, eps_sb, hyrho, kin_vis_air, k_st, l_d_cp, l_d_r,   &
-                  l_v, rho_l, r_v, schmidt_p_1d3, thermal_conductivity_l,      &
-                  t_d_pt, ventilation_effect
+           ONLY:  a_term, a_vent, b_term, b_vent, c_evap, c_term,              &
+                  diff_coeff_l, dpirho_l, eps_sb, hyrho, kin_vis_air,          &
+                  l_d_cp, l_d_r, l_v, r_v, schmidt_p_1d3,                      &
+                  thermal_conductivity_l, t_d_pt, ventilation_effect
 
        USE constants,                                                          &
@@ -594,5 +661,5 @@
 
        USE indices,                                                            &
-           ONLY:  nxl, nxr, nys, nyn, nzb, nzb_s_inner, nzt
+           ONLY:  nxl, nxr, nys, nyn, nzb_s_inner, nzt
 
        USE kinds
@@ -742,10 +809,7 @@
            ONLY:  eps_sb, hyrho, l_d_cp, nc_const, prr, pt_d_t, sed_qc_const
 
-       USE constants,                                                          &
-           ONLY:  pi
-
        USE control_parameters,                                                 &
            ONLY:  call_microphysics_at_all_substeps, dt_micro,                 &
-                  intermediate_timestep_count, precipitation
+                  intermediate_timestep_count
 
        USE cpulog,                                                             &
@@ -798,11 +862,9 @@
 !
 !--             Compute the precipitation rate due to cloud (fog) droplets
-                IF ( precipitation )  THEN
-                   IF ( call_microphysics_at_all_substeps )  THEN
-                      prr(k,j,i) = prr(k,j,i) +  sed_qc(k) / hyrho(k)          &
-                                   * weight_substep(intermediate_timestep_count)
-                   ELSE
-                      prr(k,j,i) = prr(k,j,i) + sed_qc(k) / hyrho(k)
-                   ENDIF
+                IF ( call_microphysics_at_all_substeps )  THEN
+                   prr(k,j,i) = prr(k,j,i) +  sed_qc(k) / hyrho(k)             &
+                                * weight_substep(intermediate_timestep_count)
+                ELSE
+                   prr(k,j,i) = prr(k,j,i) + sed_qc(k) / hyrho(k)
                 ENDIF
 
@@ -828,6 +890,6 @@
 
        USE cloud_parameters,                                                   &
-           ONLY:  a_term, b_term, c_term, cof, dpirho_l, eps_sb, hyrho,        &
-                  limiter_sedimentation, l_d_cp, prr,  pt_d_t, stp
+           ONLY:  a_term, b_term, c_term, dpirho_l, eps_sb, hyrho,             &
+                  limiter_sedimentation, l_d_cp, prr, pt_d_t
 
        USE control_parameters,                                                 &
@@ -857,5 +919,4 @@
        REAL(wp)     ::  d_min                      !<
        REAL(wp)     ::  dr                         !<
-       REAL(wp)     ::  dt_sedi                    !<
        REAL(wp)     ::  flux                       !<
        REAL(wp)     ::  lambda_r                   !<
@@ -865,6 +926,4 @@
        REAL(wp), DIMENSION(nzb:nzt+1) ::  c_nr     !<
        REAL(wp), DIMENSION(nzb:nzt+1) ::  c_qr     !<
-       REAL(wp), DIMENSION(nzb:nzt+1) ::  d_nr     !<
-       REAL(wp), DIMENSION(nzb:nzt+1) ::  d_qr     !<
        REAL(wp), DIMENSION(nzb:nzt+1) ::  nr_slope !<
        REAL(wp), DIMENSION(nzb:nzt+1) ::  qr_slope !<
@@ -876,5 +935,4 @@
        CALL cpu_log( log_point_s(60), 'sed_rain', 'start' )
 
-       IF ( intermediate_timestep_count == 1 )  prr(:,:,:) = 0.0_wp
 !
 !--    Compute velocities 
@@ -1105,11 +1163,11 @@
 
        USE cloud_parameters,                                                   &
-           ONLY:  cp, hyrho, nc_const, pt_d_t, r_d, t_d_pt
+           ONLY:  cp, hyrho, nc_const, prr, pt_d_t, r_d, t_d_pt
 
        USE control_parameters,                                                 &
            ONLY:  call_microphysics_at_all_substeps, drizzle, dt_3d, dt_micro, &
                   g, intermediate_timestep_count, large_scale_forcing,         &
-                  lsf_surf, precipitation, pt_surface,                         &
-                  rho_surface,surface_pressure
+                  lsf_surf, microphysics_seifert, microphysics_kessler,        &
+                  pt_surface, rho_surface, surface_pressure
 
        USE indices,                                                            &
@@ -1162,5 +1220,5 @@
        qc_1d(:) = qc(:,j,i)
        nc_1d(:) = nc_const
-       IF ( precipitation )  THEN
+       IF ( microphysics_seifert )  THEN
           qr_1d(:) = qr(:,j,i)
           nr_1d(:) = nr(:,j,i)
@@ -1168,7 +1226,16 @@
 
 !
+!--    Reset precipitation rate
+       IF ( intermediate_timestep_count == 1 )  prr(:,j,i) = 0.0_wp
+
+!
 !--    Compute cloud physics
-       IF ( precipitation )  THEN
-          CALL adjust_cloud( i,j ) 
+       IF( microphysics_kessler )  THEN
+
+          CALL autoconversion_kessler( i,j )
+
+       ELSEIF ( microphysics_seifert )  THEN
+
+          CALL adjust_cloud( i,j )
           CALL autoconversion( i,j )
           CALL accretion( i,j )
@@ -1176,11 +1243,10 @@
           CALL evaporation_rain( i,j )
           CALL sedimentation_rain( i,j )
+
+          IF ( drizzle )  CALL sedimentation_cloud( i,j )
+
        ENDIF
 
-       IF ( drizzle )  CALL sedimentation_cloud( i,j )
-
-       IF ( precipitation )  THEN
-          CALL calc_precipitation_amount( i,j )
-       ENDIF
+       CALL calc_precipitation_amount( i,j )
 
 !
@@ -1188,5 +1254,5 @@
        q(:,j,i)  = q_1d(:)
        pt(:,j,i) = pt_1d(:)
-       IF ( precipitation )  THEN
+       IF ( microphysics_seifert )  THEN
           qr(:,j,i) = qr_1d(:)
           nr(:,j,i) = nr_1d(:)
@@ -1210,8 +1276,8 @@
 
        USE cloud_parameters,                                                   &
-           ONLY:  eps_sb, xrmin, xrmax, hyrho, k_cc, x0
+           ONLY:  eps_sb, xrmin, xrmax, hyrho
 
        USE indices,                                                            &
-           ONLY:  nzb, nzb_s_inner, nzt
+           ONLY:  nzb_s_inner, nzt
 
        USE kinds
@@ -1258,5 +1324,5 @@
        USE cloud_parameters,                                                   &
            ONLY:  a_1, a_2, a_3, b_1, b_2, b_3, beta_cc, c_1, c_2, c_3,        &
-                  c_const, dpirho_l, eps_sb, hyrho, k_cc, kin_vis_air, x0
+                  c_const, dpirho_l, eps_sb, hyrho, kin_vis_air, k_cc, x0
 
        USE control_parameters,                                                 &
@@ -1267,5 +1333,5 @@
 
        USE indices,                                                            &
-           ONLY:  nzb, nzb_s_inner, nzt
+           ONLY:  nzb_s_inner, nzt
 
        USE kinds
@@ -1287,5 +1353,4 @@
        REAL(wp)     ::  rc                !<
        REAL(wp)     ::  re_lambda         !<
-       REAL(wp)     ::  selfcoll          !<
        REAL(wp)     ::  sigma_cc          !<
        REAL(wp)     ::  tau_cloud         !<
@@ -1366,4 +1431,54 @@
     END SUBROUTINE autoconversion_ij
 
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Autoconversion process (Kessler, 1969).
+!------------------------------------------------------------------------------!
+    SUBROUTINE autoconversion_kessler_ij( i, j )
+
+       USE arrays_3d,                                                          &
+           ONLY:  dzw, pt_1d, q_1d, qc_1d
+
+       USE cloud_parameters,                                                   &
+           ONLY:  l_d_cp, pt_d_t, prec_time_const, prr, ql_crit
+
+       USE control_parameters,                                                 &
+           ONLY:  dt_micro
+
+       USE indices,                                                            &
+           ONLY:  nzb_2d, nzt
+
+       USE kinds
+
+
+       IMPLICIT NONE
+
+       INTEGER(iwp) ::  i !<
+       INTEGER(iwp) ::  j !<
+       INTEGER(iwp) ::  k !<
+
+       REAL(wp)    ::  dqdt_precip !<
+
+       DO  k = nzb_2d(j,i)+1, nzt
+
+          IF ( qc_1d(k) > ql_crit )  THEN
+             dqdt_precip = prec_time_const * ( qc_1d(k) - ql_crit )
+          ELSE
+             dqdt_precip = 0.0_wp
+          ENDIF
+
+          qc_1d(k) = qc_1d(k) - dqdt_precip * dt_micro
+          q_1d(k)  = q_1d(k)  - dqdt_precip * dt_micro
+          pt_1d(k) = pt_1d(k) + dqdt_precip * dt_micro * l_d_cp * pt_d_t(k)
+
+!
+!--       Compute the rain rate
+          prr(nzb_2d(j,i)+1,j,i) = prr(nzb_2d(j,i)+1,j,i) +                    &
+                                   dqdt_precip * dzw(k)
+
+       ENDDO
+
+    END SUBROUTINE autoconversion_kessler_ij
 
 !------------------------------------------------------------------------------!
@@ -1384,5 +1499,5 @@
 
        USE indices,                                                            &
-           ONLY:  nzb, nzb_s_inner, nzt
+           ONLY:  nzb_s_inner, nzt
 
        USE kinds
@@ -1398,5 +1513,4 @@
        REAL(wp)     ::  phi_ac            !<
        REAL(wp)     ::  tau_cloud         !<
-       REAL(wp)     ::  xc                !<
 
        DO  k = nzb_s_inner(j,i)+1, nzt
@@ -1453,5 +1567,5 @@
 
        USE indices,                                                            &
-           ONLY:  nzb, nzb_s_inner, nzt
+           ONLY:  nzb_s_inner, nzt
 
        USE kinds
@@ -1507,6 +1621,6 @@
        USE cloud_parameters,                                                   &
            ONLY:  a_term, a_vent, b_term, b_vent, c_evap, c_term, diff_coeff_l,&
-                  dpirho_l, eps_sb, hyrho, kin_vis_air, k_st, l_d_cp, l_d_r,   &
-                  l_v, rho_l, r_v, schmidt_p_1d3, thermal_conductivity_l,      &
+                  dpirho_l, eps_sb, hyrho, kin_vis_air, l_d_cp, l_d_r,         &
+                  l_v, r_v, schmidt_p_1d3, thermal_conductivity_l,             &
                   t_d_pt, ventilation_effect
 
@@ -1518,5 +1632,5 @@
 
        USE indices,                                                            &
-           ONLY:  nzb, nzb_s_inner, nzt
+           ONLY:  nzb_s_inner, nzt
 
        USE kinds
@@ -1655,10 +1769,7 @@
            ONLY:  eps_sb, hyrho, l_d_cp, prr, pt_d_t, sed_qc_const
 
-       USE constants,                                                          &
-           ONLY:  pi
-
        USE control_parameters,                                                 &
-           ONLY:  call_microphysics_at_all_substeps, dt_do2d_xy, dt_micro,     &
-                  intermediate_timestep_count, precipitation
+           ONLY:  call_microphysics_at_all_substeps, dt_micro,                 &
+                  intermediate_timestep_count
 
        USE indices,                                                            &
@@ -1701,11 +1812,9 @@
 !
 !--       Compute the precipitation rate of cloud (fog) droplets
-          IF ( precipitation )  THEN
-             IF ( call_microphysics_at_all_substeps )  THEN
-                prr(k,j,i) = prr(k,j,i) + sed_qc(k) / hyrho(k) *               &
+          IF ( call_microphysics_at_all_substeps )  THEN
+             prr(k,j,i) = prr(k,j,i) + sed_qc(k) / hyrho(k) *               &
                              weight_substep(intermediate_timestep_count)
-             ELSE
-                prr(k,j,i) = prr(k,j,i) +  sed_qc(k) / hyrho(k)
-             ENDIF
+          ELSE
+             prr(k,j,i) = prr(k,j,i) + sed_qc(k) / hyrho(k)
           ENDIF
 
@@ -1727,13 +1836,10 @@
 
        USE cloud_parameters,                                                   &
-           ONLY:  a_term, b_term, c_term, cof, dpirho_l, eps_sb, hyrho,        &
-                  limiter_sedimentation, l_d_cp, precipitation_amount, prr,    &
-                  pt_d_t, stp
+           ONLY:  a_term, b_term, c_term, dpirho_l, eps_sb, hyrho,             &
+                  limiter_sedimentation, l_d_cp, prr, pt_d_t
 
        USE control_parameters,                                                 &
-           ONLY:  call_microphysics_at_all_substeps, dt_do2d_xy, dt_micro,     &
-                  dt_3d, intermediate_timestep_count,                          &
-                  intermediate_timestep_count_max,                             &
-                  precipitation_amount_interval, time_do2d_xy
+           ONLY:  call_microphysics_at_all_substeps, dt_micro,                 &
+                  intermediate_timestep_count
 
        USE indices,                                                            &
@@ -1757,5 +1863,4 @@
        REAL(wp)     ::  d_min                      !<
        REAL(wp)     ::  dr                         !<
-       REAL(wp)     ::  dt_sedi                    !<
        REAL(wp)     ::  flux                       !<
        REAL(wp)     ::  lambda_r                   !<
@@ -1765,6 +1870,4 @@
        REAL(wp), DIMENSION(nzb:nzt+1) ::  c_nr     !<
        REAL(wp), DIMENSION(nzb:nzt+1) ::  c_qr     !<
-       REAL(wp), DIMENSION(nzb:nzt+1) ::  d_nr     !<
-       REAL(wp), DIMENSION(nzb:nzt+1) ::  d_qr     !<
        REAL(wp), DIMENSION(nzb:nzt+1) ::  nr_slope !<
        REAL(wp), DIMENSION(nzb:nzt+1) ::  qr_slope !<
@@ -1774,5 +1877,4 @@
        REAL(wp), DIMENSION(nzb:nzt+1) ::  w_qr     !<
 
-       IF ( intermediate_timestep_count == 1 )  prr(:,j,i) = 0.0_wp
 !
 !--    Compute velocities 
@@ -1939,6 +2041,5 @@
            ONLY:  call_microphysics_at_all_substeps, dt_do2d_xy, dt_3d,        &
                   intermediate_timestep_count, intermediate_timestep_count_max,&
-                  precipitation_amount_interval,         &
-                  time_do2d_xy
+                  precipitation_amount_interval, time_do2d_xy
 
        USE indices,                                                            &
Index: palm/trunk/SOURCE/mod_particle_attributes.f90
===================================================================
--- palm/trunk/SOURCE/mod_particle_attributes.f90	(revision 1821)
+++ palm/trunk/SOURCE/mod_particle_attributes.f90	(revision 1822)
@@ -19,6 +19,8 @@
 ! Current revisions:
 ! ------------------
+! +collision_algorithm, all_or_nothing, average_impact
 ! 
-! 
+! Tails removed.
+!
 ! Former revisions:
 ! -----------------
@@ -47,24 +49,25 @@
     USE kinds
 
-    CHARACTER(LEN=15) ::  bc_par_lr = 'cyclic',  bc_par_ns = 'cyclic',         &
-                          bc_par_b  = 'reflect', bc_par_t  = 'absorb',         &
-                          collision_kernel = 'none'
+    CHARACTER(LEN=15) ::  bc_par_lr = 'cyclic'                    !< left/right boundary condition
+    CHARACTER(LEN=15) ::  bc_par_ns = 'cyclic'                    !< north/south boundary condition
+    CHARACTER(LEN=15) ::  bc_par_b  = 'reflect'                   !< bottom boundary condition
+    CHARACTER(LEN=15) ::  bc_par_t  = 'absorb'                    !< top boundary condition
+    CHARACTER(LEN=15) ::  collision_algorithm = 'all_or_nothing'  !< collision algorithm
+    CHARACTER(LEN=15) ::  collision_kernel = 'none'               !< collision kernel
 
-    INTEGER(iwp) ::  deleted_particles = 0, deleted_tails = 0,                 &
+    INTEGER(iwp) ::  deleted_particles = 0,                                    &
                      dissipation_classes = 10, ibc_par_lr,                     &
                      ibc_par_ns, ibc_par_b, ibc_par_t, iran_part = -1234567,   &
                      maximum_number_of_particles = 0,                          &
-                     maximum_number_of_tailpoints = 100,                       &
-                     maximum_number_of_tails = 0,                              &
                      min_nr_particle = 50,                                     &
                      mpi_particle_type,                                        &
                      number_of_particles = 0,                                  &
-                     number_of_particle_groups = 1, number_of_tails = 0,       &
-                     number_of_initial_tails = 0, number_of_sublayers = 20,    &
+                     number_of_particle_groups = 1,                            &
+                     number_of_sublayers = 20,                                 &
                      offset_ocean_nzt = 0,                                     &
                      offset_ocean_nzt_m1 = 0, particles_per_point = 1,         &
                      particle_file_count = 0, radius_classes = 20,             &
-                     skip_particles_for_tail = 100, sort_count = 0,            &
-                     total_number_of_particles, total_number_of_tails = 0,     &
+                     sort_count = 0,                                           &
+                     total_number_of_particles,                                &
                      trlp_count_sum, trlp_count_recv_sum, trrp_count_sum,      &
                      trrp_count_recv_sum, trsp_count_sum, trsp_count_recv_sum, &
@@ -73,27 +76,23 @@
     INTEGER(iwp), PARAMETER ::  max_number_of_particle_groups = 10
 
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE     ::  new_tail_id
     INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE ::  prt_count
 
-    LOGICAL ::  hall_kernel = .FALSE., palm_kernel = .FALSE.,                  &
+    LOGICAL ::  all_or_nothing = .FALSE., average_impact = .FALSE.,            &
+                hall_kernel = .FALSE., palm_kernel = .FALSE.,                  &
                 particle_advection = .FALSE., random_start_position = .FALSE., &
                 read_particles_from_restartfile = .TRUE.,                      &
                 seed_follows_topography = .FALSE.,                             &
                 uniform_particles = .TRUE., use_kernel_tables = .FALSE.,       &
-                use_particle_tails = .FALSE., use_sgs_for_particles = .FALSE., &
-                wang_kernel = .FALSE., write_particle_statistics = .FALSE.
+                use_sgs_for_particles = .FALSE., wang_kernel = .FALSE.,        &
+                write_particle_statistics = .FALSE.
 
     LOGICAL, DIMENSION(max_number_of_particle_groups) ::                       &
                 vertical_particle_advection = .TRUE.
 
-    LOGICAL, DIMENSION(:), ALLOCATABLE ::  tail_mask
-
     REAL(wp) ::  alloc_factor = 20.0_wp, c_0 = 3.0_wp,                         &
                  dt_min_part = 0.0002_wp, dt_prel = 9999999.9_wp,              &
                  dt_write_particle_data = 9999999.9_wp,                        &
-                 dvrp_psize = 9999999.9_wp, end_time_prel = 9999999.9_wp,      &
+                 end_time_prel = 9999999.9_wp,                                 &
                  initial_weighting_factor = 1.0_wp,                            &
-                 maximum_tailpoint_age = 100000.0_wp,                          &
-                 minimum_tailpoint_distance = 0.0_wp,                          &
                  particle_advection_start = 0.0_wp,                            &
                  sgs_wfu_part = 0.3333333_wp, sgs_wfv_part = 0.3333333_wp,     &
@@ -108,21 +107,8 @@
                  pss = 9999999.9_wp, pst = 9999999.9_wp, radius = 9999999.9_wp
 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  particle_tail_coordinates
-
     REAL(wp), DIMENSION(:), ALLOCATABLE     ::  log_z_z0
 
     TYPE particle_type
         SEQUENCE
-#if defined( __twocachelines )
-        REAL(wp)     ::  radius
-        REAL(sp)     ::  x, y, z, speed_x, speed_y, speed_z
-        REAL(wp)     ::  weight_factor, rvar1, dt_sum
-        INTEGER(iwp) ::  class
-        LOGICAL      ::  particle_mask
-
-        REAL(wp)     ::  dvrp_psize, rvar2, rvar3
-        REAL(sp)     ::  age, origin_x, origin_y, origin_z, e_m, age_m
-        INTEGER(iwp) ::  group, tailpoints, tail_id, block_nr
-#else
         REAL(wp)     ::  radius, age, age_m, dt_sum, dvrp_psize, e_m,          &
                          origin_x, origin_y, origin_z, rvar1, rvar2, rvar3,    &
@@ -131,10 +117,8 @@
         LOGICAL      ::  particle_mask
         INTEGER(iwp) ::  block_nr
-#endif
-!-- One 32 Bit word for 64 Bit alignment in Type declaration
     END TYPE particle_type
 
-    TYPE(particle_type), DIMENSION(:), POINTER             ::  particles
-    TYPE(particle_type)                                    ::  zero_particle
+    TYPE(particle_type), DIMENSION(:), POINTER ::  particles
+    TYPE(particle_type)                        ::  zero_particle
 
     TYPE particle_groups_type
Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 1821)
+++ palm/trunk/SOURCE/modules.f90	(revision 1822)
@@ -19,5 +19,6 @@
 ! Current revisions:
 ! ------------------
-!
+! icloud_scheme removed. microphysics_sat_adjust, microphysics_kessler, 
+! microphysics_seifert added. 
 !
 ! Former revisions:
@@ -626,5 +627,5 @@
                              bc_sa_t = 'neumann', &
                              bc_uv_b = 'dirichlet', bc_uv_t = 'dirichlet', &
-                             cloud_scheme = 'seifert_beheng', &
+                             cloud_scheme = 'saturation_adjust', &
                              coupling_mode = 'uncoupled', &
                              coupling_mode_remote = 'uncoupled', &
@@ -665,5 +666,5 @@
                      grid_level, ibc_e_b, ibc_p_b, ibc_p_t, &
                      ibc_pt_b, ibc_pt_t, ibc_q_b, ibc_q_t, &
-                     ibc_sa_t, ibc_uv_b, ibc_uv_t, icloud_scheme, &
+                     ibc_sa_t, ibc_uv_b, ibc_uv_t, &
                      inflow_disturbance_begin = -1, inflow_disturbance_end = -1, &
                      intermediate_timestep_count, intermediate_timestep_count_max, &
@@ -734,5 +735,9 @@
                 lsf_vert = .TRUE., lptnudge = .FALSE., lqnudge = .FALSE., &
                 lunudge = .FALSE., lvnudge = .FALSE., lwnudge = .FALSE., &
-                masking_method = .FALSE., mg_switch_to_pe0 = .FALSE., &
+                masking_method = .FALSE., &
+                microphysics_sat_adjust = .FALSE., &
+                microphysics_kessler = .FALSE., &
+                microphysics_seifert = .FALSE., &
+                mg_switch_to_pe0 = .FALSE., &
                 monotonic_adjustment = .FALSE.
     LOGICAL ::  nest_bound_l = .FALSE. !< nested boundary on left side
